#include <iostream.h>
#include <graphics.h>
#include <conio.h>

class TTrangle {
  protected:
    int v_x[3];
    int v_y[3];
    void Draw();
    void Move(int dx, int dy);
  public:
    TTrangle(int x1, int y1, int x2, int y2, int x3, int y3)
    {
      v_x[0] = x1;
      v_x[1] = x2;
      v_x[2] = x3;
      v_y[0] = y1;
      v_y[1] = y2;
      v_y[2] = y3;
      cout << " 㣮쭨\n";
    }
    ~TTrangle()
    {
      cout << "⮦ 㣮쭨\n";
    }
};

void TTrangle::Draw()
{
  moveto(v_x[0], v_y[0]);
  for (int i = 0; i < 3; i++)
    lineto(v_x[(i + 1) % 3], v_y[(i + 1) % 3]);
}

void TTrangle::Move(int dx, int dy)
{
  for (int i = 0; i < 3; i++)
  {
    v_x[i] += dx;
    v_y[i] += dy;
  }
}

class TRect {
  protected:
    int x, y, w, h;
    void Draw()
    {
      rectangle(x, y, x + w, y + h);
    }
    void Move(int dx, int dy)
    {
      x += dx;
      y += dy;
    }
  public:
    TRect(int x1, int y1, int x2, int y2)
    {
      x1 < x2 ? x = x1 : x = x2;
      x1 < x2 ? w = x2 - x1 : w = x1 - x2;
      y1 < y2 ? y = y1 : y = y2;
      y1 < y2 ? h = y2 - y1 : h = y1 - y2;
      cout << " אַ㣮쭨\n";
    }
    ~TRect()
    {
      cout << "⮦ אַ㣮쭨\n";
    }
};

class TCircle {
  protected:
    int x, y, r;
    void Draw()
    {
      circle(x, y, r);
    }
    void Move(int dx, int dy)
    {
      x += dx;
      y += dy;
    }
  public:
    TCircle(int x, int y, int r)
    {
      TCircle::x = x;
      TCircle::y = y;
      TCircle::r = r;
      cout << " 㦭\n";
    }
    ~TCircle()
    {
      cout << "⮦ 㦭\n";
    }
};

class TFigure: public TRect, TCircle, TTrangle {
    int x, y, a;
  public:
    TFigure(int cx, int cy, int a):
           TRect(cx - a, cy - a, cx + a, cy + a),
           TCircle(cx, cy, a),
           TTrangle(cx - a, cy, cx + a, cy, cx, cy - a)
    {
      TFigure::x = cx;
      TFigure::y = cy;
      TFigure::a = a;
      cout << " 䨣\n";
      Draw(false);
    }
    ~TFigure()
    {
      Draw(true);
      cout << "⮦ 䨣\n";
    }
    void Draw(bool erase)
    {
      if (erase)
      {
        setfillstyle(1, 0);
        bar(x - a, y - a, x + a, y + a);
        return;
      }
      setcolor(15);
      TRect::Draw();
      TCircle::Draw();
      setfillstyle(1, 1);
      floodfill(x, y, 15);
      TTrangle::Draw();
      setfillstyle(1, 2);
      floodfill(x, y - 1, 15);
    }
    void Move(int dx, int dy)
    {
      Draw(true);
      x += dx;
      y += dy;
      TRect::Move(dx, dy);
      TCircle::Move(dx, dy);
      TTrangle::Move(dx, dy);
      Draw(false);
    }
};

void main()
{
  int gd = DETECT, gm;

  registerbgidriver(EGAVGA_driver);
  initgraph(&gd, &gm, "");

  TFigure *t = new TFigure(getmaxx() / 2, getmaxy() / 2, 100);
  cout << "\n";
  getch();
  for (int i = 0; i < (getmaxx() - 200) / 2; i++)
    t -> Move(1, 0);
  getch();
  for (int i = 0; i < (getmaxy() - 200) / 2; i++)
    t -> Move(-1, 1);
  getch();
  delete t;
  getch();

  closegraph();
  restorecrtmode();
}
